#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
    
    color[0].set(255, 192, 0);
	color[1].set(61,90,163);
	color[2].set(234,255, 0);
	color[3].set(61,90,163);
	color[4].set(138, 255, 0);
	color[5].set(61,90,163);
	color[6].set(0, 255, 174);
	color[7].set(61,90,163);
	color[8].set(255,0,48);
	
    //set center position
    center.setInitialCondition(ofGetWidth()/2, ofGetHeight()/2, 0, 0);
    
    //set outside points
	for(int i=0;i<5; i++){
        particle myParticle;
        //parameters = setInitialCondition(pos.x, pos.y, vel.x, vel.y)
        myParticle.setInitialCondition( ofGetWidth()/2 + 300*cos(i*-PI/5-PI/10), ofGetHeight()/2 + 200* sin(i*-PI/5-PI/10),0,0 );
        particlesOutside.push_back(myParticle);        
    
    }
    
    //set inside points
    for(int i=0;i<10; i++){
        particle myParticle;
        myParticle.setInitialCondition( ofGetWidth()/2 + 200*cos(i*-PI/10-PI/20), ofGetHeight()/2 + 150* sin(i*-PI/10-PI/20),0,0 );
        particlesInside.push_back(myParticle);
    }

	
    //draw strings
	spring mySpring;
    
    //draw feather tops
    for (int j = 0; j < particlesInside.size(); j++){
        
        //mySpring.distance		=  ofDist(particlesInside[0].pos.x, particlesOutside[0].pos.x,particlesInside[0].pos.y, particlesOutside[0].pos.y);
        mySpring.distance = 50;
        mySpring.springiness	= 0.2f;
         
        //draw string from odd inside particle to the correct outside particle
        if(j%2 == 1){
            mySpring.particleA = & (particlesInside[(j)]);
            mySpring.particleB = & (particlesOutside[((j+1)/2-1)]);
        }
        //draw string from even inside particle to the correct outside particle
        if(j%2 == 0){
            mySpring.particleA = & (particlesInside[(j)]);
            mySpring.particleB = & (particlesOutside[j/2]);
        }

        springs.push_back(mySpring);

    }
    
    //draw feather bottoms
    for (int j = 0; j < particlesInside.size(); j++){
        
        //mySpring.distance		=  ofDist(particlesInside[0].pos.x, particlesOutside[0].pos.x,particlesInside[0].pos.y, particlesOutside[0].pos.y);
        mySpring.distance = 100;
        mySpring.springiness	= 0.2f;
        mySpring.particleA = & (particlesInside[(j)]);
        mySpring.particleB = & (center);

        springs.push_back(mySpring);
        
    }
    
    //draw string between inside particles (feather width)
    for (int j = 0; j < particlesInside.size(); j+=2){
        
        //mySpring.distance		=  ofDist(particlesInside[0].pos.x, particlesInside[1].pos.x,particlesInside[0].pos.y, particlesInside[1].pos.y);
        mySpring.distance = 50;
        mySpring.springiness	= 0.2f;
        mySpring.particleA = & (particlesInside[(j)]);
        mySpring.particleB = & (particlesInside[j+1]);
        
        springs.push_back(mySpring);
        
    }
    
    //draw string between outside and center particles (feather height)
    for (int j = 0; j < particlesOutside.size(); j++){
        
        //mySpring.distance		=  ofDist(particlesOutside[0].pos.x, center.pos.x,particlesOutside[0].pos.y, center.pos.y);
        mySpring.distance = 200;
        mySpring.springiness	= 0.2f;
        mySpring.particleA = & (particlesOutside[(j)]);
        mySpring.particleB = & (center);
        
        springs.push_back(mySpring);
        
    }
    
    //draw string between outside particles
    /*for (int j = 0; j < particlesOutside.size(); j++){
        
        //mySpring.distance		=  ofDist(particlesOutside[0].pos.x, center.pos.x,particlesOutside[0].pos.y, center.pos.y);
        mySpring.distance = 150;
        mySpring.springiness	= 0.2f;
        mySpring.particleA = & (particlesOutside[(j)]);
        mySpring.particleB = & (particlesOutside[(j+1)]);
        
        springs.push_back(mySpring);
        
    }*/

	
	
		
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	//springs[0].distance = 100 + 50 * sin(ofGetElapsedTimef()*8);
	//springs[2].distance = 100 + 50 * sin(ofGetElapsedTimef()*8 + PI);
    
    //springs[springs.size() -1].distance = 100 + 40 * sin(ofGetElapsedTimef()*2 + PI);
    //springs[5].distance = 100 + 40 * cos(ofGetElapsedTimef()*2 + PI);
	
//    springs[4].distance = 40 + 10 * cos(ofGetElapsedTimef()*9.5 + PI);
//    springs[springs.size() -3].distance = 40 + 10 * sin(ofGetElapsedTimef()*9.5 + PI);
	
	
	for (int i = 0; i < particlesInside.size(); i++){
		particlesInside[i].resetForce();
	}
    for (int i = 0; i < particlesOutside.size(); i++){
		particlesOutside[i].resetForce();
	}
    center.resetForce();
	
	for (int i = 0; i < particlesInside.size(); i++){
		particlesInside[i].addForce(0,-0.1f);
		particlesInside[i].addRepulsionForce(mouseX, mouseY, 1500, 0.7f);
	}
    for (int i = 0; i < particlesOutside.size(); i++){
		particlesOutside[i].addForce(0,-0.1f);
		particlesOutside[i].addRepulsionForce(mouseX, mouseY, 150, 0.7f);
	}
    
    center.addForce(0,0.1f);
	center.addRepulsionForce(mouseX,mouseY, 300, 0.7f);
	
	for (int i = 0; i < springs.size(); i++){
        //springs[i].distance = 100 + 50 * sin(ofGetElapsedTimef()*8);
        
        //crazy shit
        //springs[i].distance = 300 * sin(ofGetElapsedTimef());
        
		springs[i].update();
	}
	

	
	for (int i = 0; i < particlesInside.size(); i++){
		particlesInside[i].bounceOffWalls();
		particlesInside[i].addDampingForce();
		particlesInside[i].update();
	}
    for (int i = 0; i < particlesOutside.size(); i++){
		particlesOutside[i].bounceOffWalls();
		particlesOutside[i].addDampingForce();
		particlesOutside[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	

	ofSetColor(0xffffff);
	
    //center.draw();
    
    
    //ofSetColor(0xffffff);
	
    //color by piuggi
	/*for (int i = 0; i < particlesOutside.size() -1; i++){
		
        ofSetColor(color[i*2+1].r, color[i*2+1].g, color[i*2+1].b);
        
        ofBeginShape();
            ofVertex(particlesOutside[i].pos.x, particlesOutside[i].pos.y);
            ofVertex(center.pos.x, center.pos.y);
            ofVertex(particlesOutside[i+1].pos.x, particlesOutside[i+1].pos.y);
        ofEndShape();
        
	}*/
	
    //center.draw();
	
    //color by piuggi
	for (int i = 0; i < particlesOutside.size(); i++){
		ofSetColor( color[i*2].r ,  color[i*2].g , color[i*2].b);
        
		//particlesOutside[i].draw();
		
		ofBeginShape();
            ofVertex(center.pos.x, center.pos.y);
            ofVertex(particlesInside[i*2].pos.x, particlesInside[i*2].pos.y);
            ofVertex(particlesOutside[i].pos.x, particlesOutside[i].pos.y);
            ofVertex(particlesInside[i*2+1].pos.x, particlesInside[i*2+1].pos.y);
		ofEndShape();
		
		//particlesInside[i*2].draw();
		//particlesInside[i*2+1].draw();
		
        
		
	}
    
	/*for (int i = 0; i < particlesOutside.size(); i++){
		particlesOutside[i].draw();
	}
    
    for (int i = 0; i < particlesInside.size(); i++){
        particlesInside[i].draw();
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].draw();
	}*/
    
    ofSetColor(0xffffff);
    center.draw(10);

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
//	switch (key){
//			
//		case ' ':
//			// reposition everything: 
//			for (int i = 0; i < particles.size(); i++){
//				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
//			}
//			break;
//	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
//	particles[0].pos.set(mouseX, mouseY);
	/*particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	particles.push_back(myParticle);*/
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
//	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
//	particles[0].bFixed = false;
}

